﻿Module DataTableExtension

   <System.Runtime.CompilerServices.Extension()> _
   Public Function ToDataTable(Of T)(ByVal value As IEnumerable(Of T)) As DataTable

      Dim returnTable As New DataTable
      Dim firstRecord = value.First

      For Each pi In firstRecord.GetType.GetProperties
         returnTable.Columns.Add(pi.Name, pi.GetValue(firstRecord, Nothing).GetType)
      Next

      For Each result In value
         Dim nr = returnTable.NewRow
         For Each pi In result.GetType.GetProperties
            nr(pi.Name) = pi.GetValue(result, Nothing)
         Next
         returnTable.Rows.Add(nr)
      Next
      Return returnTable
   End Function
End Module
