﻿Public Class frmMainForm
    WithEvents bsCustomers As New BindingSource()
    WithEvents bsCustomersClone As New BindingSource
    WithEvents bsThird As New BindingSource

    Private Sub Form2_Load() Handles MyBase.Load
        '
        ' Load xml data from project resource into a DataTable
        ' which is assigned to the DataSource of the BindingSource
        ' for use as the DataSource for the top DataGridView
        '
        bsCustomers.DataSource = _
        ( _
           From customer In XDocument.Parse(My.Resources.Customers)...<Customer> _
           Select New With _
           { _
             .Identifier = customer.<CustomerID>.Value, _
             .CompanyName = customer.<CompanyName>.Value, _
             .Address = customer.<Address>.Value, _
             .City = customer.<City>.Value, _
             .Country = customer.<Country>.Value _
            } _
        ).ToDataTable

        TopGrid.DataSource = bsCustomers

        Dim dt As New DataTable
        bsCustomersClone.DataSource = dt.Clone

        BottomGrid.DataSource = bsCustomersClone


        Dim dt1 As New DataTable

        dt1.Columns.AddRange( _
           New DataColumn() _
            { _
               New DataColumn("Identifier", GetType(System.String)), _
               New DataColumn("CompanyName", GetType(System.String)), _
               New DataColumn("Whatever", GetType(System.String)) _
            } _
           )

        bsThird.DataSource = dt1
        DataGridView1.DataSource = bsThird

    End Sub
    Private Sub DataGridView1_MouseDoubleClick() Handles TopGrid.MouseDoubleClick
        '
        ' Match columns
        '
        bsCustomers.CloneCurrentRow(bsCustomersClone, "Identifier", True, True)
        '
        ' Do not match columns
        '
        bsCustomers.CloneCurrentRow(bsThird, "Identifier", True, False)
    End Sub
    Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
        Close()
    End Sub
End Class